/*
 *   -- micMAGMA (version 0.1) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 *   @precisions normal z -> s d c
 */

#ifndef MAGMA_Z_BINDINGS
#define MAGMA_Z_BINDINGS

typedef struct {
    magma_trans_t transa;
    magma_trans_t transb;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaDoubleComplex alpha;
    magmaDoubleComplex_const_ptr a;
    magma_int_t lda;
    magmaDoubleComplex_const_ptr b;
    magma_int_t ldb;
    magmaDoubleComplex beta;
    magmaDoubleComplex_const_ptr c;
    magma_int_t ldc;
} magma_mic_zgemm_param;

typedef struct {
  magma_trans_t transa;
  magma_int_t m;
  magma_int_t n;
  magmaDoubleComplex alpha;
  magmaDoubleComplex_const_ptr a;
  magma_int_t lda;
  magmaDoubleComplex_const_ptr x;
  magma_int_t incx;
  magmaDoubleComplex beta;
  magmaDoubleComplex_const_ptr y;
  magma_int_t incy;
} magma_mic_zgemv_param;


typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDoubleComplex_const_ptr a;
    magma_int_t lda;
    double beta;
    magmaDoubleComplex_const_ptr c;
    magma_int_t ldc;
} magma_mic_zherk_param;


typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    magmaDoubleComplex alpha;
    magmaDoubleComplex_const_ptr a;
    magma_int_t lda;
    magmaDoubleComplex_const_ptr b;
    magma_int_t ldb;
} magma_mic_ztrsm_param;


typedef struct {
    int direct;
    int storev;
    magma_int_t n;
    magma_int_t k;
    magmaDoubleComplex_const_ptr v;
    magma_int_t ldv;
    magmaDoubleComplex_const_ptr tau;
    magmaDoubleComplex_const_ptr t;
    magma_int_t ldt;
} magma_mic_zlarft_param;


typedef struct {
    int side;
    int trans;
    int direct;
    int storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaDoubleComplex_const_ptr v;
    magma_int_t ldv;
    magmaDoubleComplex_const_ptr t;
    magma_int_t ldt;
    magmaDoubleComplex_const_ptr c;
    magma_int_t ldc;
    magmaDoubleComplex_const_ptr work;
    magma_int_t ldwork;
} magma_mic_zlarfb_param;


typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    magmaDoubleComplex alpha;
    magmaDoubleComplex_const_ptr a;
    magma_int_t lda;
    magmaDoubleComplex_const_ptr b;
    magma_int_t ldb;
} magma_mic_ztrmm_param;


typedef struct {
    magmaDoubleComplex_const_ptr odata;
    magma_int_t ldo;
    magmaDoubleComplex_const_ptr idata;
    magma_int_t ldi;
    magma_int_t m;
    magma_int_t n;
} magma_mic_ztranspose_param;


/*typedef struct {
    magmaDoubleComplex_const_ptr d_AT;
    magma_int_t lda;
    magma_int_t *d_ipiv;
    magma_int_t nb;
    magma_int_t ind;
} magma_mic_zlaswp_param;*/


typedef struct {
    magma_int_t n;
    magmaDoubleComplex_const_ptr d_A;
    magma_int_t lda;
    magma_int_t k1;
    magma_int_t k2;
    magma_int_t *d_ipiv;
    magma_int_t incx;
} magma_mic_zlaswp_param;

#endif  // MAGMA_Z_BINDINGS
