#ifndef MAGMA_C_SERVER_H
#define MAGMA_C_SERVER_H

/*
 *   -- micMAGMA (version 0.1) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 * @generated c Thu Dec 13 14:39:22 2012
 */

#include <mkl.h>

#include <mkl_trans.h>
#include <scif.h>
#include <fcntl.h>
#include <offload.h>

#if 0
#ifdef __MIC__
#define _M512_TYPED
#include <lmmintrin.h>
#endif
#endif
//#include <immintrin.h>

#include "magma.h"
#include "magma_c_bindings.h"

void call_cgemm(magma_mic_cgemm_param cgemm_param);

void call_cgemv(magma_mic_cgemv_param cgemv_param);

void call_ctrsm(magma_mic_ctrsm_param ctrsm_param);

void call_ctrmm(magma_mic_ctrmm_param ctrmm_param);

void call_cherk(magma_mic_cherk_param cherk_param);

void call_clarft(magma_mic_clarft_param clarft_param);

void call_clarfb(magma_mic_clarfb_param clarfb_param);

void call_ctranspose(magma_mic_ctranspose_param ctranspose_param);

void call_ctranspose_mkl(magma_mic_ctranspose_param ctranspose_param);

void call_claswp(magma_mic_claswp_param claswp_param);

#define SREG_WIDTH 16
#define DREG_WIDTH 8

#define _MM512_LOAD_PPS _mm512_load_ps
#define _MM512_LOAD_PPD _mm512_load_pd

#define _MM512_STORE_PPS _mm512_store_ps
#define _MM512_STORE_PPD _mm512_store_pd

#define _MM512_I32LOEXTSCATTER_PPS _mm512_i32extscatter_ps
#define _MM512_I32LOEXTSCATTER_PPD _mm512_i32loextscatter_pd

#define __M512S __m512
#define __M512D __m512d
#endif // MAGMA_C_SERVER_H
