#ifndef MAGMA_S_SERVER_H
#define MAGMA_S_SERVER_H

/*
 *   -- micMAGMA (version 0.1) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 * @generated s Thu Dec 13 14:39:22 2012
 */

#include <mkl.h>

#include <mkl_trans.h>
#include <scif.h>
#include <fcntl.h>
#include <offload.h>

#if 0
#ifdef __MIC__
#define _M512_TYPED
#include <lmmintrin.h>
#endif
#endif
//#include <immintrin.h>

#include "magma.h"
#include "magma_s_bindings.h"

void call_sgemm(magma_mic_sgemm_param sgemm_param);

void call_sgemv(magma_mic_sgemv_param sgemv_param);

void call_strsm(magma_mic_strsm_param strsm_param);

void call_strmm(magma_mic_strmm_param strmm_param);

void call_ssyrk(magma_mic_ssyrk_param ssyrk_param);

void call_slarft(magma_mic_slarft_param slarft_param);

void call_slarfb(magma_mic_slarfb_param slarfb_param);

void call_stranspose(magma_mic_stranspose_param stranspose_param);

void call_stranspose_mkl(magma_mic_stranspose_param stranspose_param);

void call_slaswp(magma_mic_slaswp_param slaswp_param);

#define SREG_WIDTH 16
#define DREG_WIDTH 8

#define _MM512_LOAD_PPS _mm512_load_ps
#define _MM512_LOAD_PPD _mm512_load_pd

#define _MM512_STORE_PPS _mm512_store_ps
#define _MM512_STORE_PPD _mm512_store_pd

#define _MM512_I32LOEXTSCATTER_PPS _mm512_i32extscatter_ps
#define _MM512_I32LOEXTSCATTER_PPD _mm512_i32loextscatter_pd

#define __M512S __m512
#define __M512D __m512d
#endif // MAGMA_S_SERVER_H
