#ifndef MAGMA_Z_SERVER_H
#define MAGMA_Z_SERVER_H

/*
 *   -- micMAGMA (version 0.1) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 * @precisions normal z -> s d c
 */

#include <mkl.h>

#include <mkl_trans.h>
#include <scif.h>
#include <fcntl.h>
#include <offload.h>

#if 0
#ifdef __MIC__
#define _M512_TYPED
#include <lmmintrin.h>
#endif
#endif
//#include <immintrin.h>

#include "magma.h"
#include "magma_z_bindings.h"

void call_zgemm(magma_mic_zgemm_param zgemm_param);

void call_zgemv(magma_mic_zgemv_param zgemv_param);

void call_ztrsm(magma_mic_ztrsm_param ztrsm_param);

void call_ztrmm(magma_mic_ztrmm_param ztrmm_param);

void call_zherk(magma_mic_zherk_param zherk_param);

void call_zlarft(magma_mic_zlarft_param zlarft_param);

void call_zlarfb(magma_mic_zlarfb_param zlarfb_param);

void call_ztranspose(magma_mic_ztranspose_param ztranspose_param);

void call_ztranspose_mkl(magma_mic_ztranspose_param ztranspose_param);

void call_zlaswp(magma_mic_zlaswp_param zlaswp_param);

#define SREG_WIDTH 16
#define DREG_WIDTH 8

#define _MM512_LOAD_PPS _mm512_load_ps
#define _MM512_LOAD_PPD _mm512_load_pd

#define _MM512_STORE_PPS _mm512_store_ps
#define _MM512_STORE_PPD _mm512_store_pd

#define _MM512_I32LOEXTSCATTER_PPS _mm512_i32extscatter_ps
#define _MM512_I32LOEXTSCATTER_PPD _mm512_i32loextscatter_pd

#define __M512S __m512
#define __M512D __m512d
#endif // MAGMA_Z_SERVER_H
